package com.java2s.common;

import java.util.ArrayList;
import java.util.Collection;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;

@Entity
public class Professor {
  @Id @GeneratedValue(strategy=GenerationType.IDENTITY)
  private int id;
  private String name;
  private long salary;
  
  @ManyToMany 
  private Collection<Project> projects;

  public Professor() {
      projects = new ArrayList<Project>();
  }

  public int getId() {
      return id;
  }
  
  public void setId(int id) {
      this.id = id;
  }
  
  public String getName() {
      return name;
  }
  
  public void setName(String name) {
      this.name = name;
  }

  public long getSalary() {
      return salary;
  }

  public void setSalary(long salary) {
      this.salary = salary;
  }
  
  public void addProject(Project project) {
      if (!getProjects().contains(project)) {
          getProjects().add(project);
      }
      if (!project.getEmployees().contains(this)) {
          project.getEmployees().add(this);
      }
  }

  public Collection<Project> getProjects() {
      return projects;
  }

  public String toString() {
      return "Employee id: " + getId() + " name: " + getName() + 
             " with " + getProjects().size() + " projects";
  }
}
